-- Games and their data

--Aeltari data
--Cards
cards = {
		snake         = { gfx = lg.newImage(aelPath.."3122_snake.png"),       u = 3, r = 1, d = 2, l = 2 },
		spider        = { gfx = lg.newImage(aelPath.."1122_spider.png"),      u = 1, r = 1, d = 2, l = 2 },
		tangleweedI   = { gfx = lg.newImage(aelPath.."2111_tangleweedI.png"), u = 2, r = 1, d = 1, l = 1 }
		}
		
		
deck = { cards.snake, cards.snake, cards.spider, cards.spider, cards.spider, cards.spider, cards.tangleweedI }

hand = { }
ophand = { }

texred = lg.newImage(aelPath.."texred.png")
texblu = lg.newImage(aelPath.."texblue.png")

function cardDraw()
	lg.setColor(colors.white)
	--Backs
	for i = 1, 9 do
		if grido[i] ~= nil then
			if grido[i] then
				cback = texblu
			else
				cback = texred
			end
			if i <= 3 then
				lg.draw(cback, (96 * (i - 1) + 32), 0)
			elseif i <= 6 then
				lg.draw(cback, (96 * (i - 4) + 32), 128)
			else
				lg.draw(cback, (96 * (i - 7) + 32), 256)
			end
		end
	end
	
	--Fronts
	for i = 1, 9 do
		if gridf[i] ~= nil then
			if i <= 3 then
				lg.draw(gridf[i].gfx, (96 * (i - 1) + 32), 0)
			elseif i <= 6 then
				lg.draw(gridf[i].gfx, (96 * (i - 4) + 32), 128)
			else
				lg.draw(gridf[i].gfx, (96 * (i - 7) + 32), 256)
			end
		end
	end
end

function handDraw()
	lg.setColor(colors.white)
	local midway = lw.getHeight() / 2 - 48
	lg.draw(activecardgui, 2, midway - 32)
	if ls.getOS() ~= "Android" then
	--if not android then
		lg.draw(activecard.gfx, 20, midway)
	else
		lg.draw(activecard.gfx, 32, midway)
	end
end

function detHand()
	local drawnlist = { }
	local firstrun = true
	math.randomseed(os.time())
	for i = 1, 5 do
		local cardinvalid = true
		local drawncard = round(math.random(1, #deck))
		while cardinvalid do
			print("Drew "..drawncard.." on "..i)
			if firstrun then
				firstrun = false
				break
			end
			for e = 1, #drawnlist do
				if drawncard ~= drawnlist[e] then
					cardinvalid = false
				else
					cardinvalid = true
					print("rerun")
					drawncard = round(math.random(1, #deck))
					break
				end
			end
		end
		table.insert(hand, deck[drawncard])
		table.insert(drawnlist, drawncard)
	end
	print("Hand has "..#hand.." cards")
	activecard = hand[1]
	activecardnum = 1
	print(Tserial.pack(drawnlist))
	detopHand()
end

function detopHand()
	if opdeck == nil then
		opdeck = deck
	end
	local drawnlist = { }
	local firstrun = true
	math.randomseed(os.time())
	for i = 1, 5 do
		local cardinvalid = true
		local drawncard = round(math.random(1, #opdeck))
		while cardinvalid do
			print("Drew "..drawncard.." on "..i)
			if firstrun then
				firstrun = false
				break
			end
			for e = 1, #drawnlist do
				if drawncard ~= drawnlist[e] then
					cardinvalid = false
				else
					cardinvalid = true
					print("rerun")
					drawncard = round(math.random(1, #opdeck))
					break
				end
			end
		end
		table.insert(ophand, opdeck[drawncard])
		table.insert(drawnlist, drawncard)
	end
	print("opHand has "..#ophand.." cards")
	activeopcard = ophand[1]
	activeopcardnum = 1
	print(Tserial.pack(drawnlist))
end

function opPlace()
	math.randomseed(os.time())
	activeopcardnum = math.random(1, #ophand)
	local playplace = math.random(1, 9)
	local placeinvalid = true
	while placeinvalid do
		print("Checkin op place...")
		if gridf[playplace] == nil then
			print("Place found at"..playplace.."!")
			placeCard(ophand[activeopcardnum], playplace, false)
			placeinvalid = false
			break
		else
			print("invalid, try again...")
			playplace = math.random(1, 9)
			placeinvalid = true
		end
	end
end

function placeCard(plcdcard, plcdnum, plcr)
	if plcdcard == nil or plcdnum == nil or plcdnum < 1 or plcdnum > 9 or plcr == nil or gridf[plcdnum] ~= nil then
		return
	end
	
	print("Placing card at "..plcdnum)
	gridf[plcdnum] = plcdcard
	grido[plcdnum] = plcr
	if plcr then
		table.remove(hand, activecardnum)
		activecard = hand[1]
	else
		table.remove(ophand, activeopcardnum)
		activeopcard = ophand[1]
	end
	
	evaluateGrid(plcdnum, plcr)
	if plcr then
		opPlace()
	end
end

function evaluateGrid(grids, plcr)
	local attackCard = gridf[grids]
	local battleTotal = 0
	
	if gridtype == nil or gridtype == "3x3" then
		local fights = { false, false, false, false }
		if grids > 3 and gridf[grids - 3] ~= nil and grido[grids - 3] ~= plcr then
			battleTotal = battleTotal + (attackCard.u - gridf[grids - 3].d)
			fights[1] = true
		end
		if (grids % 3) ~= 0 and gridf[grids + 1] ~= nil and grido[grids + 1] ~= plcr then
			battleTotal = battleTotal + (attackCard.r - gridf[grids + 1].l)
			fights[2] = true
		end
		if grids < 7 and gridf[grids + 3] ~= nil and grido[grids + 3] ~= plcr then
			battleTotal = battleTotal + (attackCard.d - gridf[grids + 3].u)
			fights[3] = true
		end
		if (not (grids == 1 or grids == 4 or grids == 7)) and gridf[grids - 1] ~= nil and grido[grids - 1] ~= plcr then
			battleTotal = battleTotal + (attackCard.l - gridf[grids - 1].r)
			fights[4] = true
		end
		
		print(battleTotal)
		
		if battleTotal < 0 then
			grido[grids] = not grido[grids]
		elseif battleTotal == 0 then
			--NO CHANGE
		else
			if fights[1] then
				grido[grids - 3] = plcr
			end
			if fights[2] then
				grido[grids + 1] = plcr
			end
			if fights[3] then
				grido[grids + 3] = plcr
			end
			if fights[4] then
				grido[grids - 1] = plcr
			end
		end
	end
end