-- RPG
-- Author: Zephyros "Firfox" Raiyah (aka TheRedRaccoon)
-- A simple RPG in the works...

-- SHORTCUTS
la = love.audio
le = love.event
lf = love.filesystem
lg = love.graphics
lk = love.keyboard
lm = love.mouse
ls = love.system
lt = love.timer
lw = love.window
musPath = "music/"
sndPath = "sounds/"
chrPath = "graphics/characters/"
sysPath = "graphics/system/"
andPath = "graphics/system/mini/"
aelPath = "graphics/aeltcards/"
sldPath = "graphics/solids/"
arc_path = "arc/"
print("save dir: "..lf.getSaveDirectory())
lf.write("blank", "Makin' a dir!")

--test
if ls.getOS() ~= "Android" then
	--lw.setMode(1280, 720)
end

-- Require here
sti = require "sti"
if ls.getOS() ~= "Android" then
  require "lib/postshader"
  require "lib/light"
end
require "misc"
require "snm"
require "camera"
require "SpriteAnimation"
require "Tserial"
require "mapFunctions"
require "msgData"
require "party"
require "controls"
Timer = require "timer"
State = require "venus"
require "states.teststate"
require "states.blankstate"
require "states.teststate2"
require "states.blankstategrid"
require "bac"

require "games"

-- System Variables
devview = 0
savestate = -1
lf.createDirectory("Save_"..savestate)
lf.createDirectory("Save_"..savestate.."/locData")
locData = "Save_"..savestate.."/locData/"
txtFont = lg.newImageFont('fonts/font4.png'," abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,!?-+/():;%&`'*#=[]\"")
lg.setFont(txtFont)
print("savestate: "..savestate)
print("os: "..ls.getOS())
initLoadStr = "This is a test game by TheRedRaccoon!\nLoading maps and states..."

function love.load()
	print("Hello world! ~ Loading")
	dimsW, dimsH = lg.getWidth(), lg.getHeight()
  Timer.add(.25, function()
    loadMaps()
    State.registerEvents()
    initLoadStr = initLoadStr.."COMPLETE!\nLoading BAC and audio assets..."
  end)
	
  Timer.add(1, function()
    loadAudioAssets()
    loadBACAssets()
    initLoadStr = initLoadStr.."COMPLETE!"
  end)
  
	Timer.add(5, function() State.switch(blankstate) end)
end

function love.update(dt)
	Timer.update(dt)
  
  -- show FPS
  love.window.setTitle("Test (FPS:" .. lt.getFPS() .. ") (adt:" .. lt.getAverageDelta() .. ")")
end

function love.draw()
	sprint(initLoadStr, 5, 5)
end

function love.resize(w, h)
	dimsW, dimsH = w, h
    map:resize(w, h)
	print("Screen resized!: "..w.."x"..h)
end

-- Math functions

function round(num, idp) -- just to keep numbers clean...
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end