-- Colors
colors = {--          R    G    B    A
    white = 	     { 255, 255, 255, 255 },
    igmtext = 	   { 255, 255, 255, 255 },
    black = 	     {   0,   0,   0, 255 },
    red = 	       { 255,   0,   0, 255 },
    green = 	     {   0, 255,   0, 255 },
    blue = 	       {   0,   0, 255, 255 },
    hotpink = 	   { 255,   0, 255, 255 },
    gray = 	       { 160, 160, 164, 255 },
    darkgray =     {  30,  30,  34, 255 },
    litegray =     { 180, 180, 184, 255 },
    gold =         { 207, 136,   0, 255 },
    deeporange =   { 204,  66,   0, 255 },
    steelblue =	   { 116, 134, 180, 255 },
	
	--Weather Colors
    rainGray =     { 160, 160, 182, 235 },
    snowGray =     { 160, 160, 164, 235 },
	
	-- DevView Colors
    playerRed =    { 255,   0,   0, 255 },
    solidGray =    { 175, 175, 175, 255 },
    npcBlue =      {  85,  85, 255, 255 },
    counterBrown = { 170,  85,   0, 255 },
    transferVilt = {  85,   0, 127, 255 },
    floorNoNPC =   { 106, 164,  96, 255 }
}

--Determine OS before SNM for temp android optimization
if ls.getOS() == "Android" then
	android = true
	--Extras
	andyDpad = lg.newImage(andPath.."dpad.png")
	andyA  = lg.newImage(andPath.."a.png")
	andyB  = lg.newImage(andPath.."b.png")
	activecardgui = lg.newImage(aelPath.."activecard.png")
else
	android = false
	andyDpad = lg.newImage(andPath.."dpad.png")
	andyA  = lg.newImage(andPath.."a.png")
	andyB  = lg.newImage(andPath.."b.png")
	pointer1 = lm.newCursor(sysPath.."pointer1.png", 1, 1)
	pointer2 = lm.newCursor(sysPath.."pointer2.png", 1, 1)
	lm.setCursor(pointer1)
	activecardgui = lg.newImage(aelPath.."activecard_sml.png")
end

--Things to draw if on android
function draw4andy()
	lg.setColor(255, 255, 255, 195)
	lg.draw(andyDpad, 96, lg.getHeight() - 192)
	lg.draw(andyA, lg.getWidth() - 256, lg.getHeight() - 128)
	lg.draw(andyB, lg.getWidth() - 128, lg.getHeight() - 192)
	lg.setColor(colors.white)
end

canShoot = true
numShots = 0

function shoot()
  if numShots <= 0 or (not canShoot) or player:isMoving() then
    return
  end
  local shot = {x = player.x, y = player.y}
      shot.dx, shot.dy = player.x, player.y
      shot.type = "shot"
      shot.index = #mapobjects + 1
      shot.sprite = lg.newImage(sldPath.."shot.png")
      shot.xspeed, shot.yspeed = 0, 0
      shot.speed = 1800
      shot.face = player.face
      function shot:update(dt)
        if shot.y ~= shot.dy or shot.x ~= shot.dx then
					shot.y = shot.y + round(shot.yspeed * dt) -- just to keep numbers clean...
					shot.x = shot.x + round(shot.xspeed * dt) -- just to keep numbers clean...
					if (shot.yspeed < 0 and shot.y <= shot.dy) or (shot.yspeed > 0 and shot.y >= shot.dy) or (shot.xspeed > 0 and shot.x >= shot.dx) or (shot.xspeed < 0 and shot.x <= shot.dx) then
						shot.yspeed = 0
						shot.xspeed = 0
						shot.y = shot.dy
						shot.x = shot.dx
					end
        else
          if shot.face == "up" and checkCol(shot.dx, shot.dy, 0, -1, true) then
            shot.yspeed = -shot.speed
            shot.dy = shot.dy - 32
          elseif shot.face == "up" and not checkCol(shot.dx, shot.dy, 0, -1, true) then
            local notimportant, testCol = checkCol(shot.dx, shot.dy, 0, -1, true)
            if testCol then
              if testCol:hit() then
              else
                print("false hit error!")
              end
            end
            table.remove(mapobjects, shot.index)
            Timer.add(.1, function() canShoot = true end)
          end
          if shot.face == "down" and checkCol(shot.dx, shot.dy, 0, 1, true) then
            shot.yspeed = shot.speed
            shot.dy = shot.dy + 32
          elseif shot.face == "down" and not checkCol(shot.dx, shot.dy, 0, 1, true) then
            local notimportant, testCol = checkCol(shot.dx, shot.dy, 0, 1, true)
            if testCol then
              if testCol:hit() then
              else
                print("false hit error!")
              end
            end
            table.remove(mapobjects, shot.index)
            Timer.add(.1, function() canShoot = true end)
          end
          if shot.face == "right" and checkCol(shot.dx, shot.dy, 1, 0, true) then
            shot.xspeed = shot.speed
            shot.dx = shot.dx + 32
          elseif shot.face == "right" and not checkCol(shot.dx, shot.dy, 1, 0, true) then
            local notimportant, testCol = checkCol(shot.dx, shot.dy, 1, 0, true)
            if testCol then
              if testCol:hit() then
              else
                print("false hit error!")
              end
            end
            table.remove(mapobjects, shot.index)
            Timer.add(.1, function() canShoot = true end)
          end
          if shot.face == "left" and checkCol(shot.dx, shot.dy, -1, 0, true) then
            shot.xspeed = -shot.speed
            shot.dx = shot.dx - 32
          elseif shot.face == "left" and not checkCol(shot.dx, shot.dy, -1, 0, true) then
            local notimportant, testCol = checkCol(shot.dx, shot.dy, -1, 0, true)
            if testCol then
              if testCol:hit() then
              else
                print("false hit error!")
              end
            end
            table.remove(mapobjects, shot.index)
            Timer.add(.1, function() canShoot = true end)
          end
				end
				--shot.sprite:update(dt)
      end
      function shot:draw()
        lg.setColor(colors.white)
        --lg.rectangle('line', shot.x, shot.y, 32, 32)
        lg.draw(shot.sprite, shot.x, shot.y)
      end
      table.insert(mapobjects, shot)
      canShoot = false
      numShots = numShots - 1
      print("shot")
      la.play(shotsound)
end

msgWindow = lg.newImage("graphics/system/window.png")
msgWindowX = lg.getWidth() / 2 - (544 / 2)
msgWindowY = lg.getHeight() - 128
msgX = msgWindowX + 20
msgY = lg.getHeight() - 96

function debugsprints()
	if android then
		sprint("DROID!", dimsW - 32, dimsH - 12)
		sprint("savedir: "..lf.getSaveDirectory(), 0, 0)
	end
  
  msgs()
	
	if devview == 1 or devview == 2 then
		sprint("devview "..devview, 5, 5)
		sprint("FPS: "..lt.getFPS(), 5, 15)
		sprint("Map: "..c_map.." - "..map.properties["sysname"], 5, 25)
	end
  
  
  sprint(numShots, 0, 16)
end

function sprint(text, txtx, txty)
	lg.setColor(colors.black)
	lg.print(text, (txtx + 1), (txty + 1))
	lg.setColor(colors.white)
	lg.print(text, txtx, txty)
end

function encryptString(str,code)
	-- character table
    chars = "1234567890!@#$%^&*()qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM ,<.>/?;:'[{]}|`~"
	-- new code begin
    newcode = ""
	-- we start
    for i=1, 999 do
        if string.sub(str,i,i) == "" then
            break
        else
			com=string.sub(str,i,i)
		end
        for x=1, 90 do
			cur=string.sub(chars,x,x)
			if com == cur then
				new=x+code
				while new > 90 do
					new = new - 90
				end
				newcode=""..newcode..""..string.sub(chars,new,new)..""
			end
		end
    end
    print("you new code is: "..newcode.."")
    return newcode
end

function unencryptString(str,code)
	-- character table
    chars = "1234567890!@#$%^&*()qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM ,<.>/?;:'[{]}|`~"
	-- new code begin
    newcode = ""
	-- we start
    for i=1, 999 do
        if string.sub(str,i,i) == "" then
            break
        else
			com=string.sub(str,i,i)
		end
        for x=1, 90 do
			cur=string.sub(chars,x,x)
			if com == cur then
				new=x-code
				while new < 0 do
					new = new + 90
				end
				newcode=""..newcode..""..string.sub(chars,new,new)..""
			end
		end
    end
    print("you old string is: "..newcode.."")
    return newcode
end