blankstate = { }

function blankstate:init() -- runs once
	loadMap(2)
  Timer.add(3, function() killsplash = true end)
end

function blankstate:enter() -- runs every time
  if map.properties["stallcam"] then
    stallcam = true
  elseif map.properties["xonlycam"] then
    xonlycam = true
  elseif map.properties["yonlycam"] then
    yonlycam = true
  else
    stallcam = false
    xonlycam = false
    yonlycam = false
  end
  if map.properties["hasLightWorld"] then
  -- create light world
    lightWorld = love.light.newWorld()
    lightWorld.setAmbientColor(15, 15, 31) -- optional

    -- create light (x, y, red, green, blue, range)
    lightMouse = lightWorld.newLight(0, 0, 63, 127, 255, 300)
    lightMouse.setGlowStrength(.3) -- optional
    
    --imgtest = lightWorld.newImage(lg.newImage(sldPath.."TEST.png"), findObjNamed("test", true).x, findObjNamed("test", true).y, 32, 32, 0, 0)
    lwActive = true
  else
    lwActive = false
  end
   local pindex = findObjNamed("Player")
   camera:setPosition(math.floor(mapobjects[pindex].x + 16 - lg.getWidth() / 2), math.floor(mapobjects[pindex].y + 16 - lg.getHeight() / 2))
  if map.properties["bgm"] then
    if bgmold ~= nil and bgmold ~= bgm[tonumber(map.properties["bgm"])] then
      la.stop(bgmold)
    end
    if bgm[tonumber(map.properties["bgm"])] ~= nil then
      bgmold = bgm[tonumber(map.properties["bgm"])]
      la.play(bgmold)
    end
  end
end

function blankstate:update(dt)
	map:update(dt)	
	updateObjs(dt)
  
  if killsplash then
    local splash = map.layers["Splash"]
    splash.opacity = splash.opacity - (.75 * dt)
    if splash.opacity <= 0 then
      killsplash = false
      onMainMenu = true
    end
  end
  
  if numKeys == 0 and mapobjects[findObjNamed("chest")].chestopen == false then
    unstallMap()
    mapobjects[findObjNamed("chest")]:open()
  end
	
	--center camera
	local pindex = findObjNamed("Player")
  if not stallcam then
    camera:setPosition(math.floor(mapobjects[pindex].x + 16 - lg.getWidth() / 2), math.floor(mapobjects[pindex].y + 16 - lg.getHeight() / 2))
  end
  if xonlycam then
    camera:setX(math.floor(mapobjects[pindex].x + 16 - lg.getWidth() / 2))
  end
  
  if lwActive then
  -- set light to mouse position
    lightMouse.setPosition(lm.getX(), lm.getY())
    
  -- update shadow
  --local shadex = findObjNamed("test", true)
  --imgtest.setPosition(shadex.x - camera._x, shadex.y - camera._y)
  end
end

function blankstate:draw()
  if lwActive then
    lightWorld.update()
  end
	camera:set()
  lg.setColor(colors.white)
  map:draw()
  camera:unset()
  if lwActive then
    lightWorld.drawShadow()
    lightWorld.drawShine()
  end
  
  if stagecall == "menu" then
    State.switch(blankstate)
    stagecall = nil
    Timer.add(.5, function() loadMap(2) end)
  end
  
  if stagecall == "first" then
    State.switch(blankstate)
    stagecall = nil
    Timer.add(.5, function() loadMap(3) playercontrols = true end)
  end
  
  if stagecall == "next" then
    State.switch(blankstate)
    stagecall = nil
    Timer.add(.5, function() loadMap(c_map + 1) end)
  end
  
  if android then
		draw4andy()
	end
	
	debugsprints()
end

function blankstate:leave()
  onMainMenu = false
  killsplash = false
end